; CONSOLE #
include win64a.inc
MAXSCREENX = 49
MAXSCREENY = 36
.code
WinMain proc
local hFile:qword
local szReadWrite:qword
local FileSize:qword    
local hMapping:qword
local pMapping:qword
local ConsoleWindow:SMALL_RECT
local cci:CONSOLE_CURSOR_INFO
local MOUSE_KEY:INPUT_RECORD
local i:dword
local buffer1[512+3]:byte
local buffer2[3*512]:byte
local buffer3:qword
 
        	xor     ebx,ebx
        invoke  FreeConsole
        invoke  AllocConsole
        invoke	GetStdHandle,STD_INPUT_HANDLE
        mov     hIn,rax
        invoke  GetStdHandle,STD_OUTPUT_HANDLE
        mov 	hOut,rax
    	invoke  GetLargestConsoleWindowSize,rax
;   eax return in 31-16 bits: dwCoord.y
;                 15-00 bits: dwCoord.x
 
        lea 	r8d,ConsoleWindow       ; lpConsoleWindow
    	and 	dword ptr [r8],0
;   ConsoleWindow.Left = 0  ConsoleWindow.Top  = 0
 
    	sub 	ax, MAXSCREENX
    	sbb 	edx, edx
    	and 	ax, dx
    	add 	ax, MAXSCREENX-1
    	mov 	[r8+SMALL_RECT.Right],ax
 
    	shr 	eax, 16
    	sub 	eax, MAXSCREENY
    	sbb 	edx, edx
    	and 	eax, edx
    	add 	eax, MAXSCREENY-1
    	mov 	[r8+SMALL_RECT.Bottom],ax
 
    	invoke  SetConsoleWindowInfo,hOut,TRUE                                        
    	invoke  SetConsoleScreenBufferSize,hOut,MAXSCREENY*10000h+MAXSCREENX;establish the new size of a window of the console
        invoke  SetConsoleTitle,&Str0
;hide cursor----------------------------------------
    	invoke  GetConsoleCursorInfo,hOut,&cci
        lea 	edx,cci                 ; lpConsoleCursorInfo
    	mov 	[rdx+CONSOLE_CURSOR_INFO.bVisible],ebx;FALSE
    	invoke  SetConsoleCursorInfo,hOut
;------------------------------------------------------
;open physical drive
    	invoke	CreateFile,&filename,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,0,0      ;open file
	inc 	eax         ;eax == INVALID_HANDLE_VALUE ? 
    	jz  	EXIT
    	dec 	eax
    	mov 	hFile,rax
;alignment on limit of the double word
    	lea     eax,buffer1
    	add 	eax,3
    	and 	eax,-4
    	mov 	buffer3,rax
;read from Partition Table
    	invoke	ReadFile,hFile,rax,512,&szReadWrite,0
;-------------------------------------------
    	lea 	edi,buffer2
    	mov 	esi,offset Str2
    	mov 	ecx,sizeof Str2
    	rep 	movsb
 
    	mov 	rsi,buffer3
    	mov 	FileSize,sizeof Str2
    	mov 	i,ebx
@@: 	lodsq
    	bswap   rax
    	mov     r9d,eax
    	mov     [rsp+20h],r9
    	shr 	rax,32
        mov     r9d,eax
    	lodsq
    	bswap   rax
    	mov 	edx,eax
    	mov     [rsp+30h],rdx
    	shr 	rax,32
    	mov     [rsp+28h],rax
    	invoke	wsprintf,rdi,&fmt,i
    	add 	edi,eax
    	add 	FileSize,rax
    	inc 	i
    	cmp 	i,512/16
    	jb  	@b
    	mov 	esi,offset Str1
    	mov 	ecx,sizeof Str1
    	rep 	movsb
        add 	FileSize,sizeof Str1
;to bring buffer contents to the console
    	invoke  WriteConsole,hOut,&buffer2,FileSize,&szReadWrite,0
;close handle and file----------------------
    	invoke  CloseHandle,hFile ; close file
    	invoke  CloseHandle,hOut     ; close file
;--------------------------------------------------------
@@:     invoke  ReadConsoleInput,hIn,&MOUSE_KEY,1,&szReadWrite
        lea 	eax,MOUSE_KEY
    	cmp 	[rax+INPUT_RECORD.EventType],MOUSE_EVENT
    	je  	@b
    	cmp 	[rax+INPUT_RECORD.EventType],KEY_EVENT
    	jne 	@b
    	cmp 	[rax+INPUT_RECORD.KeyEvent.wVirtualKeyCode],VK_ESCAPE
    	jne 	@b
;---------------------------------------------------------
EXIT:	invoke  CloseHandle,hIn
    	invoke  FreeConsole
    	invoke	RtlExitUserProcess,NULL
WinMain endp
fmt 	db ' %.04X0 ',0BAh,' %.08X %.08X ',0B3h,' %.08X %.08X ',0BAh,0Dh,0Ah,0
Str0 	db 'Master Boot Record',0
Str1 	db 7 dup(20h),0C8h,19 dup (0CDh),0CFh,19 dup (0CDh),0BCh,13,10,\
'For exit press ESC or CTRL+C or CTRL+Break'
filename db "\\.\PhysicalDrive0",0 ;  ( )
hIn	dq ?
hOut	dq ?
Str2    db 10 dup(20h),'0 1 2 3  4 5 6 7    8 9 A B  C D E F',0Dh,0Ah,\
7 dup(20h),0C9h,19 dup (0CDh),0D1h,19 dup (0CDh),0BBh,0Dh,0Ah
end